/**********************************************************************
Copyright (c) 2005, 2006 IBM Corporation and others.
All rights reserved.  This program and the accompanying materials
are made available under the terms of the Eclipse Public License v1.0
which accompanies this distribution, and is available at
http://www.eclipse.org/legal/epl-v10.html
$Id: Agent.java,v 1.4 2006-03-28 20:04:08 rsmith Exp $

     Randy D. Smith, Intel Corporation - initial implementation based
                                         based on IBM original examples
**********************************************************************/
package org.eclipse.tptp.platform.agentcontroller.config;

import org.w3c.dom.Element;

public class Agent extends ConfigElement {
	public final static String TAG = ConfigUtility.getString("Config.Agent.Tag");

	public static void setDataChannelSize(Element elem, String value) {
		elem.setAttribute(ConfigUtility.getString("Config.Agent.DataChannelSize.Tag"), value);
	}

	public static void setName(Element elem, String value) {
		elem.setAttribute(ConfigUtility.getString("Config.Agent.Name.Tag"), value);
	}

	public static void setType(Element elem, String value) {
		elem.setAttribute(ConfigUtility.getString("Config.Agent.Type.Tag"), value);
	}

	public static void setClient(Element elem, String value) {
		elem.setAttribute(ConfigUtility.getString("Config.Agent.Client.Tag"), value);
	}
	public static void setPath(Element elem, String value) {
		elem.setAttribute(ConfigUtility.getString("Config.Agent.Path.Tag"), value);
	}

}
