/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DataChannelDemo.java,v 1.3 2005-10-01 22:03:41 sschneid Exp $
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.test.collection.framework;

/**
 * @author rduggan
 * 
 * To change this generated comment go to Window>Preferences>Java>Code
 * Generation>Code and Comments
 */
public class DataChannelDemo {

	public void start() {
		/* create the flusher */
		new Thread() {
			public void run() {
				String[] args = new String[1];
				args[0] = "datachannelSample4";
				DCFlusherProcess.main(args);
			}
		}.start();

		/* Let the filler get started */
		try {
			Thread.sleep(2000);
		} catch (Exception e) {

		}

		/* Create the filler */
		new Thread() {
			public void run() {
				String[] args = new String[1];
				args[0] = "datachannelSample4";
				DCFillerProcess.main(args);
			}
		}.start();

	}

	public static void main(String[] args) {
		DataChannelDemo demo = new DataChannelDemo();
		demo.start();
	}

}
