/*******************************************************************************
 * Copyright (c) 2011 IBM Corporation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    IBM - Initial Implementation
 * 	  
 * $Id: 
 *******************************************************************************/

package org.eclipse.hyades.loaders.internal.binary.v1;

public class BinaryTraceConstants {

	// method entry:
	public static final int TRANS_THREAD_ID_REF = 1; // "transientThreadIdRef";
	public static final int THREAD_ID_REF = 2; // "threadIdRef";
	public static final int TIME = 3;  // "time";
	public static final int METHOD_ID_REF = 4; // "methodIdRef";
	public static final int TICKET = 5; // "ticket";
	public static final int TRANS_OBJ_ID_REF = 6; // "transientObjIdRef";
	public static final int CLASS_ID_REF = 7; // "classIdRef";
	public static final int THREAD_CPU_TIME = 8; // "cpuTime";
	public static final int SEQUENCE_COUNTER = 9; // "sequenceCounter";
	public static final int STACK_DEPTH = 10; // "stackDepth";
	public static final int COLLATION_VALUE = 11; // "collationValue";
	public static final int TRACE_ID_REF = 12; // "traceIdRef";

	// method exit:
	
	public static final int OBJ_ID_REF = 13; // "objIdRef";
	public static final int TRANS_CLASS_ID_REF = 14; // "transientClassIdRef";

	// ag method entry
	
	public static final int BASE_TIME = 15; // "baseTime";
	public static final int MIN_TIME = 16; // "minTime";
	public static final int MAX_TIME = 17; // "maxTime";
	public static final int CPU_TIME = 18; // "cpuTime";
	public static final int COUNT = 19; // "count";

	public static final int IS_ARRAY = 20;
	public static final int OBJ_ID = 21;
	public static final int SIZE = 22;
	public static final int A_LINE_NR = 23;
	public static final int A_METHOD_ID_REF = 24;
	public static final int CONTEXT_DATA = 25;
	
	public static final int OBJ_AGE = 26;
	
}