/**********************************************************************
 * Copyright (c) 2003, 2007 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: XMLFragmentHandler.java,v 1.2 2007-12-01 00:06:18 apnan Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.loaders.util;

import java.io.InputStream;

/**
 * @author slavescu
 */
public interface XMLFragmentHandler {
	void scanContent(InputStream inputStream, long offset, long length); 
	void scanContent(byte[] fragment, int offset, int length) throws InvalidXMLException;
	void terminateParser();
	void setXMLLoader(IXMLLoader loader);
}