/**********************************************************************
 * Copyright (c) 2003, 2007 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: ShortList.java,v 1.2 2007-12-01 00:06:21 apnan Exp $
 **********************************************************************/
package org.eclipse.hyades.models.hierarchy.util;


/**
 * 
 * @author slavescu
 *
 */
public interface ShortList{

	ShortList clear();
	ShortList compact();
	short set(short value, int index);
	int size();
	ShortList add(short value);
	ShortList add(short value,int index);
	short get(int index);
	int indexOf(short value, int startIndex);
	int lastIndexOf(short value, int endIndex);
	short[] getValues();
	String toString();
}
