/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: PrintAction.java,v 1.2 2008-05-23 14:12:18 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

 
package org.eclipse.tptp.platform.report.ui.editor.actions.internal;
import org.eclipse.tptp.platform.report.core.internal.IDItem;
import org.eclipse.tptp.platform.report.drivers.printer.internal.DPrinterWriter;
import org.eclipse.tptp.platform.report.ui.editor.internal.ReportEditor;


/**
 * Enter here your comment
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 */
public class PrintAction extends JScribEditorAction {

    public PrintAction(ReportEditor v)
    {
    	super(v);
    }
    
	public void run() 
	{
		DPrinterWriter printer = new DPrinterWriter(getEditor().getSite().getShell());
		
		IDItem activePage = getEditor().getActiveSWTViewer().getContentItem();
		printer.setContentItem(activePage);
		printer.run();
		
		
//		IDObject[] objs = getEditor().getDocuments();
//		for (int i=0; objs!=null && i<objs.length; i++) {
//		    if (objs[i]!=null && objs[i] instanceof IDDocument) {
//		        printer.setContentItem((IDDocument)objs[i]);
//		        printer.run();
//		    }
//		}
		
	} 

}
