/*******************************************************************************
 * Copyright (c) 2005 Intel Corporation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Vishnu K Naikawadi, Intel - Initial API and Implementation
 *
 * $Id: User.cpp,v 1.1 2005-08-20 19:29:16 vnaikawadi Exp $
 *
 *******************************************************************************/ 


#include "tptp/client/User.h"

using namespace TPTP::Client;

/**
* Create an environment variable with the specified name
* value pair.
*/
User::User(char* name, char* password) 
{
	_username = name;
	_password = password;
}

/**
* Retrieve the name of this environment variable.
*/
char* User::getUserName() 
{
	return _username;
}


/**
* Set the name of this environment variable.
*/
void User::setUserName(char* name) 
{
	_username = name;
}

/**
* Retrieve the value of this environment variable.
*/
char* User::getPassword() 
{
	return _password;
}

/**
* Set the value of this environment variable.
*/
void User::setPassword(char* password) 
{
	_password = password;
}


/**
* Set the value of this environment variable.
*/
/*
void User::setPassword(char* password, EncryptService* encryptService) 
{
	char* encryptedPassword = NULL;
	if (encryptUtil != NULL)
	{
		encryptedPassword = encryptService->getEncryptUtil()->encrypt(password);
		_password = encryptedPassword;
		_passwordEncrypted = TRUE;
	}
	else
	{
		_password = password;
	}
}
*/




