/**********************************************************************
Copyright (c) 2005 IBM Corporation and others.
All rights reserved.  This program and the accompanying materials
are made available under the terms of the Eclipse Public License v1.0
which accompanies this distribution, and is available at
http://www.eclipse.org/legal/epl-v10.html
$Id: TaGridElement.java,v 1.2 2005-02-25 22:17:43 hleung Exp $

Contributors:
 IBM Rational - initial implementation
**********************************************************************/
package org.eclipse.hyades.collection.threadanalyzer;

public interface TaGridElement
{

   // returns:
   // <0 if e is less than this
   // 0 if this is equal to e
   // >0 if e is greater than this
   abstract public int compareTo( TaGridElement e );
   

   abstract public Object getAdditionalInfo();
}
