/**********************************************************************
 Copyright (c) 2005 IBM Corporation and others.
 All rights reserved.  This program and the accompanying materials
 are made available under the terms of the Eclipse Public License v1.0
 which accompanies this distribution, and is available at
 http://www.eclipse.org/legal/epl-v10.html
 $Id: INodeExtended.java,v 1.1 2005-10-28 20:11:54 sschneid Exp $
 
 Contributors:
  IBM Corporation - initial implementation
 **********************************************************************/

package org.eclipse.hyades.execution.core;

import org.eclipse.hyades.execution.core.util.ConnectionSpecifier;

/**
 * Extended node that extends the node with the capability to connect given a
 * connection specifier.
 * 
 * @author Scott E. Schneider
 */
public interface INodeExtended extends INode {
	public ISession connect(ConnectionSpecifier specifier) throws java.net.UnknownHostException, UnknownDaemonException,
			DaemonConnectException;
}
