/**********************************************************************
 Copyright (c) 2005 IBM Corporation and others.
 All rights reserved.  This program and the accompanying materials
 are made available under the terms of the Eclipse Public License v1.0
 which accompanies this distribution, and is available at
 http://www.eclipse.org/legal/epl-v10.html
 $Id: TimeoutException.java,v 1.4 2005-10-08 14:28:50 sschneid Exp $
 
 Contributors:
  IBM Corporation - initial implementation
  IBM Rational - initial implementation
 SCAPA Technologies - initial implementation
 **********************************************************************/

package org.eclipse.hyades.execution.core;

/**
 * <p>
 * This exception is thrown to indicate that a given request was unable to be
 * satisfied within the defined time limit.
 * </p>
 * 
 * @version 0.0.2
 */
public class TimeoutException extends Exception {

	/**
	 * Stream-Unique IDentifier (SUID) of this class
	 */
	private static final long serialVersionUID = 7595859706542170213L;

	public TimeoutException() {
	}

	public TimeoutException(String message) {
		super(message);
	}

}
