/**********************************************************************
 * Copyright (c) 2003, 2006 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: VirtualObjectInfo.java,v 1.3 2006-02-08 19:56:55 slavescu Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 * 
 * $Id: VirtualObjectInfo.java,v 1.3 2006-02-08 19:56:55 slavescu Exp $
 **********************************************************************/
package org.eclipse.hyades.loaders.trace;

import org.eclipse.hyades.models.trace.TRCClass;
import org.eclipse.hyades.models.trace.TRCThread;


/**
 * Objects that will be used when we mix the modes (execution after heap)
 * @author slavescu
 */
public final class VirtualObjectInfo {
    //~ Instance fields ----------------------------------------------------------------------------

    public double createTime;

    //	no need for a collectTime because we will never use it.
    public int size;
    public TRCThread myThread;
    public TRCClass myClass;
}
