/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: Common_Behavior_InteractionsPackageImpl.java,v 1.11 2009-05-13 13:20:11 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.interactions.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.hyades.models.common.common.CommonPackage;
import org.eclipse.hyades.models.common.common.impl.CommonPackageImpl;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;
import org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl;
import org.eclipse.hyades.models.common.datapool.Common_DatapoolPackage;
import org.eclipse.hyades.models.common.datapool.impl.Common_DatapoolPackageImpl;
import org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage;
import org.eclipse.hyades.models.common.fragments.impl.Common_Behavior_FragmentsPackageImpl;
import org.eclipse.hyades.models.common.interactions.BVREventOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRExecutionOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRGeneralOrdering;
import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;
import org.eclipse.hyades.models.common.interactions.BVRLifeline;
import org.eclipse.hyades.models.common.interactions.BVRMessage;
import org.eclipse.hyades.models.common.interactions.BVRMessageEnd;
import org.eclipse.hyades.models.common.interactions.BVRMessageSort;
import org.eclipse.hyades.models.common.interactions.BVRProperty;
import org.eclipse.hyades.models.common.interactions.BVRStateInvariant;
import org.eclipse.hyades.models.common.interactions.BVRStop;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsFactory;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;
import org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage;
import org.eclipse.hyades.models.common.testprofile.impl.Common_TestprofilePackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class Common_Behavior_InteractionsPackageImpl extends EPackageImpl implements Common_Behavior_InteractionsPackage
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrLifelineEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrInteractionFragmentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrMessageEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrGeneralOrderingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrEventOccurrenceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrMessageEndEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrExecutionOccurrenceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrStateInvariantEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrStopEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bvrPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum bvrMessageSortEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private Common_Behavior_InteractionsPackageImpl() {
		super(eNS_URI, Common_Behavior_InteractionsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link Common_Behavior_InteractionsPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static Common_Behavior_InteractionsPackage init() {
		if (isInited) return (Common_Behavior_InteractionsPackage)EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_InteractionsPackage.eNS_URI);

		// Obtain or create and register package
		Common_Behavior_InteractionsPackageImpl theCommon_Behavior_InteractionsPackage = (Common_Behavior_InteractionsPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof Common_Behavior_InteractionsPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new Common_Behavior_InteractionsPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		EcorePackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		CommonPackageImpl theCommonPackage = (CommonPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CommonPackage.eNS_URI) instanceof CommonPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CommonPackage.eNS_URI) : CommonPackage.eINSTANCE);
		Common_Behavior_FragmentsPackageImpl theCommon_Behavior_FragmentsPackage = (Common_Behavior_FragmentsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_FragmentsPackage.eNS_URI) instanceof Common_Behavior_FragmentsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_FragmentsPackage.eNS_URI) : Common_Behavior_FragmentsPackage.eINSTANCE);
		Common_TestprofilePackageImpl theCommon_TestprofilePackage = (Common_TestprofilePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(Common_TestprofilePackage.eNS_URI) instanceof Common_TestprofilePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(Common_TestprofilePackage.eNS_URI) : Common_TestprofilePackage.eINSTANCE);
		Common_ConfigurationPackageImpl theCommon_ConfigurationPackage = (Common_ConfigurationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(Common_ConfigurationPackage.eNS_URI) instanceof Common_ConfigurationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(Common_ConfigurationPackage.eNS_URI) : Common_ConfigurationPackage.eINSTANCE);
		Common_DatapoolPackageImpl theCommon_DatapoolPackage = (Common_DatapoolPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(Common_DatapoolPackage.eNS_URI) instanceof Common_DatapoolPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(Common_DatapoolPackage.eNS_URI) : Common_DatapoolPackage.eINSTANCE);

		// Create package meta-data objects
		theCommon_Behavior_InteractionsPackage.createPackageContents();
		theCommonPackage.createPackageContents();
		theCommon_Behavior_FragmentsPackage.createPackageContents();
		theCommon_TestprofilePackage.createPackageContents();
		theCommon_ConfigurationPackage.createPackageContents();
		theCommon_DatapoolPackage.createPackageContents();

		// Initialize created meta-data
		theCommon_Behavior_InteractionsPackage.initializePackageContents();
		theCommonPackage.initializePackageContents();
		theCommon_Behavior_FragmentsPackage.initializePackageContents();
		theCommon_TestprofilePackage.initializePackageContents();
		theCommon_ConfigurationPackage.initializePackageContents();
		theCommon_DatapoolPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theCommon_Behavior_InteractionsPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(Common_Behavior_InteractionsPackage.eNS_URI, theCommon_Behavior_InteractionsPackage);
		return theCommon_Behavior_InteractionsPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRLifeline() {
		return bvrLifelineEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRLifeline_InteractionFragments() {
		return (EReference)bvrLifelineEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRLifeline_Instances() {
		return (EReference)bvrLifelineEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRLifeline_PartDecomposition() {
		return (EReference)bvrLifelineEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRLifeline_Interaction() {
		return (EReference)bvrLifelineEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRInteractionFragment() {
		return bvrInteractionFragmentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_Lifelines() {
		return (EReference)bvrInteractionFragmentEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_GeneralOrderings() {
		return (EReference)bvrInteractionFragmentEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_Messages() {
		return (EReference)bvrInteractionFragmentEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_Annotations() {
		return (EReference)bvrInteractionFragmentEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_Interaction() {
		return (EReference)bvrInteractionFragmentEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_Properties() {
		return (EReference)bvrInteractionFragmentEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRInteractionFragment_DefaultApplication() {
		return (EReference)bvrInteractionFragmentEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRMessage() {
		return bvrMessageEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBVRMessage_MessageSort() {
		return (EAttribute)bvrMessageEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessage_ReceiveMessageEnd() {
		return (EReference)bvrMessageEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessage_SendMessageEnd() {
		return (EReference)bvrMessageEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessage_InteractionFragment() {
		return (EReference)bvrMessageEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessage_InstanceValues() {
		return (EReference)bvrMessageEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessage_Operation() {
		return (EReference)bvrMessageEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRGeneralOrdering() {
		return bvrGeneralOrderingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRGeneralOrdering_PreviousEventOccurrence() {
		return (EReference)bvrGeneralOrderingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRGeneralOrdering_NextEventOccurence() {
		return (EReference)bvrGeneralOrderingEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVREventOccurrence() {
		return bvrEventOccurrenceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVREventOccurrence_TargetGeneralOrderings() {
		return (EReference)bvrEventOccurrenceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVREventOccurrence_SourceGeneralOrderings() {
		return (EReference)bvrEventOccurrenceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVREventOccurrence_FinishExecutionOccurrence() {
		return (EReference)bvrEventOccurrenceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVREventOccurrence_StartExecutionOcurrence() {
		return (EReference)bvrEventOccurrenceEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRMessageEnd() {
		return bvrMessageEndEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessageEnd_ReceiveMessage() {
		return (EReference)bvrMessageEndEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRMessageEnd_SendMessage() {
		return (EReference)bvrMessageEndEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRExecutionOccurrence() {
		return bvrExecutionOccurrenceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRExecutionOccurrence_FinishEventOccurrence() {
		return (EReference)bvrExecutionOccurrenceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRExecutionOccurrence_BeforeEventOccurrence() {
		return (EReference)bvrExecutionOccurrenceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBVRExecutionOccurrence_OtherBehavior() {
		return (EReference)bvrExecutionOccurrenceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRStateInvariant() {
		return bvrStateInvariantEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRStop() {
		return bvrStopEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBVRProperty() {
		return bvrPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBVRProperty_Value() {
		return (EAttribute)bvrPropertyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getBVRMessageSort() {
		return bvrMessageSortEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_Behavior_InteractionsFactory getCommon_Behavior_InteractionsFactory() {
		return (Common_Behavior_InteractionsFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		bvrLifelineEClass = createEClass(BVR_LIFELINE);
		createEReference(bvrLifelineEClass, BVR_LIFELINE__INTERACTION_FRAGMENTS);
		createEReference(bvrLifelineEClass, BVR_LIFELINE__INSTANCES);
		createEReference(bvrLifelineEClass, BVR_LIFELINE__PART_DECOMPOSITION);
		createEReference(bvrLifelineEClass, BVR_LIFELINE__INTERACTION);

		bvrInteractionFragmentEClass = createEClass(BVR_INTERACTION_FRAGMENT);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__LIFELINES);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__GENERAL_ORDERINGS);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__MESSAGES);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__ANNOTATIONS);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__INTERACTION);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__PROPERTIES);
		createEReference(bvrInteractionFragmentEClass, BVR_INTERACTION_FRAGMENT__DEFAULT_APPLICATION);

		bvrMessageEClass = createEClass(BVR_MESSAGE);
		createEAttribute(bvrMessageEClass, BVR_MESSAGE__MESSAGE_SORT);
		createEReference(bvrMessageEClass, BVR_MESSAGE__RECEIVE_MESSAGE_END);
		createEReference(bvrMessageEClass, BVR_MESSAGE__SEND_MESSAGE_END);
		createEReference(bvrMessageEClass, BVR_MESSAGE__INTERACTION_FRAGMENT);
		createEReference(bvrMessageEClass, BVR_MESSAGE__INSTANCE_VALUES);
		createEReference(bvrMessageEClass, BVR_MESSAGE__OPERATION);

		bvrGeneralOrderingEClass = createEClass(BVR_GENERAL_ORDERING);
		createEReference(bvrGeneralOrderingEClass, BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE);
		createEReference(bvrGeneralOrderingEClass, BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE);

		bvrEventOccurrenceEClass = createEClass(BVR_EVENT_OCCURRENCE);
		createEReference(bvrEventOccurrenceEClass, BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS);
		createEReference(bvrEventOccurrenceEClass, BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS);
		createEReference(bvrEventOccurrenceEClass, BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE);
		createEReference(bvrEventOccurrenceEClass, BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE);

		bvrMessageEndEClass = createEClass(BVR_MESSAGE_END);
		createEReference(bvrMessageEndEClass, BVR_MESSAGE_END__RECEIVE_MESSAGE);
		createEReference(bvrMessageEndEClass, BVR_MESSAGE_END__SEND_MESSAGE);

		bvrExecutionOccurrenceEClass = createEClass(BVR_EXECUTION_OCCURRENCE);
		createEReference(bvrExecutionOccurrenceEClass, BVR_EXECUTION_OCCURRENCE__FINISH_EVENT_OCCURRENCE);
		createEReference(bvrExecutionOccurrenceEClass, BVR_EXECUTION_OCCURRENCE__BEFORE_EVENT_OCCURRENCE);
		createEReference(bvrExecutionOccurrenceEClass, BVR_EXECUTION_OCCURRENCE__OTHER_BEHAVIOR);

		bvrStateInvariantEClass = createEClass(BVR_STATE_INVARIANT);

		bvrStopEClass = createEClass(BVR_STOP);

		bvrPropertyEClass = createEClass(BVR_PROPERTY);
		createEAttribute(bvrPropertyEClass, BVR_PROPERTY__VALUE);

		// Create enums
		bvrMessageSortEEnum = createEEnum(BVR_MESSAGE_SORT);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		CommonPackage theCommonPackage = (CommonPackage)EPackage.Registry.INSTANCE.getEPackage(CommonPackage.eNS_URI);
		Common_ConfigurationPackage theCommon_ConfigurationPackage = (Common_ConfigurationPackage)EPackage.Registry.INSTANCE.getEPackage(Common_ConfigurationPackage.eNS_URI);
		Common_Behavior_FragmentsPackage theCommon_Behavior_FragmentsPackage = (Common_Behavior_FragmentsPackage)EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_FragmentsPackage.eNS_URI);
		Common_TestprofilePackage theCommon_TestprofilePackage = (Common_TestprofilePackage)EPackage.Registry.INSTANCE.getEPackage(Common_TestprofilePackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		bvrLifelineEClass.getESuperTypes().add(theCommonPackage.getCMNNamedElement());
		bvrInteractionFragmentEClass.getESuperTypes().add(theCommonPackage.getCMNNamedElement());
		bvrEventOccurrenceEClass.getESuperTypes().add(this.getBVRInteractionFragment());
		bvrMessageEndEClass.getESuperTypes().add(this.getBVREventOccurrence());
		bvrExecutionOccurrenceEClass.getESuperTypes().add(this.getBVRInteractionFragment());
		bvrStateInvariantEClass.getESuperTypes().add(this.getBVRInteractionFragment());
		bvrStopEClass.getESuperTypes().add(this.getBVREventOccurrence());
		bvrPropertyEClass.getESuperTypes().add(theCommonPackage.getCMNNamedElement());

		// Initialize classes and features; add operations and parameters
		initEClass(bvrLifelineEClass, BVRLifeline.class, "BVRLifeline", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBVRLifeline_InteractionFragments(), this.getBVRInteractionFragment(), this.getBVRInteractionFragment_Lifelines(), "interactionFragments", null, 0, -1, BVRLifeline.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRLifeline_Instances(), theCommon_ConfigurationPackage.getCFGInstance(), theCommon_ConfigurationPackage.getCFGInstance_Lifeline(), "instances", null, 1, -1, BVRLifeline.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRLifeline_PartDecomposition(), theCommon_Behavior_FragmentsPackage.getBVRPartDecomposition(), null, "partDecomposition", null, 0, 1, BVRLifeline.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRLifeline_Interaction(), theCommon_Behavior_FragmentsPackage.getBVRInteraction(), theCommon_Behavior_FragmentsPackage.getBVRInteraction_Lifelines(), "interaction", null, 1, 1, BVRLifeline.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(bvrInteractionFragmentEClass, BVRInteractionFragment.class, "BVRInteractionFragment", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBVRInteractionFragment_Lifelines(), this.getBVRLifeline(), this.getBVRLifeline_InteractionFragments(), "lifelines", null, 1, -1, BVRInteractionFragment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRInteractionFragment_GeneralOrderings(), this.getBVRGeneralOrdering(), null, "generalOrderings", null, 0, -1, BVRInteractionFragment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRInteractionFragment_Messages(), this.getBVRMessage(), this.getBVRMessage_InteractionFragment(), "messages", null, 0, -1, BVRInteractionFragment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRInteractionFragment_Annotations(), theCommonPackage.getCMNAnnotation(), null, "annotations", null, 0, -1, BVRInteractionFragment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRInteractionFragment_Interaction(), theCommon_Behavior_FragmentsPackage.getBVRInteraction(), theCommon_Behavior_FragmentsPackage.getBVRInteraction_InteractionFragments(), "interaction", null, 0, 1, BVRInteractionFragment.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRInteractionFragment_Properties(), this.getBVRProperty(), null, "properties", null, 0, -1, BVRInteractionFragment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRInteractionFragment_DefaultApplication(), theCommon_TestprofilePackage.getTPFDefaultApplication(), theCommon_TestprofilePackage.getTPFDefaultApplication_InteractionFragment(), "defaultApplication", null, 0, 1, BVRInteractionFragment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(bvrMessageEClass, BVRMessage.class, "BVRMessage", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBVRMessage_MessageSort(), this.getBVRMessageSort(), "messageSort", null, 0, 1, BVRMessage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRMessage_ReceiveMessageEnd(), this.getBVRMessageEnd(), this.getBVRMessageEnd_ReceiveMessage(), "receiveMessageEnd", null, 1, 1, BVRMessage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRMessage_SendMessageEnd(), this.getBVRMessageEnd(), this.getBVRMessageEnd_SendMessage(), "sendMessageEnd", null, 1, 1, BVRMessage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRMessage_InteractionFragment(), this.getBVRInteractionFragment(), this.getBVRInteractionFragment_Messages(), "interactionFragment", null, 1, 1, BVRMessage.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRMessage_InstanceValues(), theCommon_TestprofilePackage.getTPFInstanceValue(), null, "instanceValues", null, 0, -1, BVRMessage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRMessage_Operation(), theCommon_ConfigurationPackage.getCFGOperation(), null, "operation", null, 0, 1, BVRMessage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(bvrGeneralOrderingEClass, BVRGeneralOrdering.class, "BVRGeneralOrdering", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBVRGeneralOrdering_PreviousEventOccurrence(), this.getBVREventOccurrence(), this.getBVREventOccurrence_TargetGeneralOrderings(), "previousEventOccurrence", null, 1, 1, BVRGeneralOrdering.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRGeneralOrdering_NextEventOccurence(), this.getBVREventOccurrence(), this.getBVREventOccurrence_SourceGeneralOrderings(), "nextEventOccurence", null, 1, 1, BVRGeneralOrdering.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(bvrEventOccurrenceEClass, BVREventOccurrence.class, "BVREventOccurrence", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBVREventOccurrence_TargetGeneralOrderings(), this.getBVRGeneralOrdering(), this.getBVRGeneralOrdering_PreviousEventOccurrence(), "targetGeneralOrderings", null, 0, -1, BVREventOccurrence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVREventOccurrence_SourceGeneralOrderings(), this.getBVRGeneralOrdering(), this.getBVRGeneralOrdering_NextEventOccurence(), "sourceGeneralOrderings", null, 0, -1, BVREventOccurrence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVREventOccurrence_FinishExecutionOccurrence(), this.getBVRExecutionOccurrence(), this.getBVRExecutionOccurrence_FinishEventOccurrence(), "finishExecutionOccurrence", null, 0, 1, BVREventOccurrence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVREventOccurrence_StartExecutionOcurrence(), this.getBVRExecutionOccurrence(), this.getBVRExecutionOccurrence_BeforeEventOccurrence(), "startExecutionOcurrence", null, 0, 1, BVREventOccurrence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(bvrMessageEndEClass, BVRMessageEnd.class, "BVRMessageEnd", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBVRMessageEnd_ReceiveMessage(), this.getBVRMessage(), this.getBVRMessage_ReceiveMessageEnd(), "receiveMessage", null, 0, 1, BVRMessageEnd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRMessageEnd_SendMessage(), this.getBVRMessage(), this.getBVRMessage_SendMessageEnd(), "sendMessage", null, 0, 1, BVRMessageEnd.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(bvrExecutionOccurrenceEClass, BVRExecutionOccurrence.class, "BVRExecutionOccurrence", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBVRExecutionOccurrence_FinishEventOccurrence(), this.getBVREventOccurrence(), this.getBVREventOccurrence_FinishExecutionOccurrence(), "finishEventOccurrence", null, 1, 1, BVRExecutionOccurrence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRExecutionOccurrence_BeforeEventOccurrence(), this.getBVREventOccurrence(), this.getBVREventOccurrence_StartExecutionOcurrence(), "beforeEventOccurrence", null, 1, 1, BVRExecutionOccurrence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBVRExecutionOccurrence_OtherBehavior(), theCommon_TestprofilePackage.getTPFBehavior(), null, "otherBehavior", null, 1, 1, BVRExecutionOccurrence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(bvrStateInvariantEClass, BVRStateInvariant.class, "BVRStateInvariant", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(bvrStopEClass, BVRStop.class, "BVRStop", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(bvrPropertyEClass, BVRProperty.class, "BVRProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBVRProperty_Value(), ecorePackage.getEString(), "value", null, 0, 1, BVRProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(bvrMessageSortEEnum, BVRMessageSort.class, "BVRMessageSort");
		addEEnumLiteral(bvrMessageSortEEnum, BVRMessageSort.SYNCH_CALL_LITERAL);
		addEEnumLiteral(bvrMessageSortEEnum, BVRMessageSort.SYNCH_SIGNAL_LITERAL);
		addEEnumLiteral(bvrMessageSortEEnum, BVRMessageSort.ASYNCH_CALL_LITERAL);
		addEEnumLiteral(bvrMessageSortEEnum, BVRMessageSort.ASYNCH_SIGNAL_LITERAL);
	}

} //Common_Behavior_InteractionsPackageImpl
