/**********************************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: CommonUIConstants.java,v 1.8 2008-03-28 23:22:41 apnan Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.platform.common.ui.internal;

import org.eclipse.tptp.platform.common.internal.ICommonConstants;

public class CommonUIConstants implements ICommonConstants
{
	public static final String LOG_VIEW_ID = "org.eclipse.tptp.platform.log.views.internal.views.LogViewer";

	public static final int XMI = 0;

	public static final int SQL = 1;

	public static final int NONE = -1;

	public static final String MONITOR_EXT = "trcmxmi";

	public static final String NODE_EXT = "trcnxmi";

	public static final String AGENT_EXT = "trcaxmi";

	public static final String PROCESS_EXT = "trcpxmi";
		
	
	/**
	 * The hyades UI plugin ID
	 */
	public static final String HYADES_UI_PLUGIN_ID = "org.eclipse.hyades.ui";
	
	/**
	 * Log Navigator ID
	 */
	public static final String LOG_NAVIGATOR_ID = "org.eclipse.hyades.log.ui.logNavigator";
	
	/**
	 * Log Navigator view extension point ID
	 */
	public static final String ID_LOG_NAVIGATOR_VIEW = "org.eclipse.hyades.log.ui.internal.navigator.LogNavigator";
	/**
	 * Id of the import log action
	 */
	public static final String IMPORT_LOG_ACTION_ID = "org.eclipse.tptp.monitoring.logui.internal.actions.ImportLogAction";
	

}
