/**********************************************************************
 * Copyright (c) 2006 Intel Corporation.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: PIExtendedConfiguration.java,v 1.1 2006-09-21 19:19:40 ewchan Exp $
 * 
 **********************************************************************/
package org.eclipse.tptp.trace.ui.internal.launcher.application;


/**
 * This configuration is used to configure the JVMPI data collector.
 * It provides the following wizard pages:
 * <ol>
 *  <li> The limitation options (formerly included as a nested tab of the profile tab) </li>
 *  <li> The filteration page including automatic filtering criteria determination </li>
 * </ol> 
 *   	
 * @author Alexander Simbirtsev
 */
public class PIExtendedConfiguration extends PIConfiguration {
	/**
	 * Add the configuration pages to the parent class.
	 */
	public PIExtendedConfiguration() {
		super(FilterExtendedConfigurationPage.class);
	}
}
